<?php
// ---------------------------------------------------------------------------
// PHP Baukasten Beispielanwendung
// Autor:  Susanne Pfeiffer / www.iloq.de
// E-Mail: susanne.pfeiffer@iloq.de
// ---------------------------------------------------------------------------


if (!defined('SESSIONCLASSPHP'))
{
    define ('SESSIONCLASSPHP', 'SESSIONCLASSPHP');

    include ('globals.php');
    include ('exceptionhandling.php');
    include ('loggclass.php');
    include ('userdbmapperclass.php');

    class SessionClass
    {
	// Session Status
	//  0: nicht eingeloggt
	//  1: eingeloggt
	private $sessionstate = 0;

	// Benutzername. Ist gesetzt, wenn der
	// Benutzer eingeloggt ist. 
	private $username = '';

	public function __construct()
	{
	    session_start();
	  
	    // Ueberpruefe, ob die Session existiert
	    // und der Benutzername gesetzt ist. 
	    // Wenn der Benutzername gesetzt ist, 
	    // ist der Benutzer eingeloggt
	    if (isset($_SESSION['username']) )
		{
		    $this->username = $_SESSION['username'];
		    $this->sessionstate = 1; 
		}
	}

	// Destructor
	public function __destruct() 
	{
	}
	
	// get- und set-Methoden
	public function getState()
	{ return ($this->sessionstate); }
	
	public function setState($state)
	{ $this->sessionstate = $state; }

	public function getUsername()
	{ return $this->username; }
	
	public function setUsername($username)
	{ $this->username = $username; }

	// login-Methode
	public function login($username, $password, 
			      $dbname, $dbusername, $dbpassword)
	{
	    // Lies Benutzer $username aus Datenbank
	    try
		{
		    $myUserMapper = new UserDbMapperClass
			($dbname, $dbusername, $dbpassword);
		    $myuser = $myUserMapper->readUser($username);
		}
	    catch (Exception $e)
		{
		    LoggClass::loggErr  ("Fehler beim Lesen des Benutzers");
		    throw new Exception ("Fehler beim Lesen des Benutzers");
		}

	    // Pruefe Benutzereingabe gegen die gelesenen Werte
	    if ($myuser->isValid()
		&& $myuser->getUsername() == $username
		&& $myuser->getPassword() == $password)
		{  
		    // Wenn alle o.k. ist, setze Session-Daten
		    $_SESSION['username'] = $username;
		    $this->username = $username;
		    $this->sessionstate = 1; 
		}
	    else { $this->sessionstate = 0; }

	    return $this->sessionstate; 
	}
      

	// logout: zerstoere die Session
	public function logout()
	{
	    session_destroy(); 
	    $this->sessionstate = 0;
	    $this->username = 0;
	}     
    }
}
?>
