<?php
// ---------------------------------------------------------------------------
// PHP Baukasten Beispielanwendung
// Autor:  Susanne Pfeiffer / www.iloq.de
// E-Mail: susanne.pfeiffer@iloq.de
// ---------------------------------------------------------------------------

include ('globals.php');
include ('exceptionhandling.php');
include ('loggclass.php');
include ('session2class.php');
include ('bookdbmapperclass.php');
include ('authorclass.php');
include ('bookclass.php');
include ('html2class.php');

// Globale Benutzermeldung
$message = '';

// Instantiiere Session Objekt
// Falls ein Fehler auftritt 
// --> Abbruch und Aufruf Exception Handler
$Session = new SessionClass();

// Pruefe, ob Benutzer eingeloggt ist. 
if ( $Session->getState() >= 1 ) 
{
    try
	{
	    $DbMapper = new BookDbMapperClass
		(DBNAME, DBUSER, DBPASSWORD);
	}
    catch (Exception $e)
	{
	    // Exception Handling. 
	    // Abbruch und Aufruf Exception Handler 
	    // oder Fortsetzung ohne Datenbankzugriff
	}

    // BuchId initialisieren
    $bookid = 0;

    // setze Buch aufgrund von POST-Parametern 
    // pruefe, ob BuchId als Get-Parameter uebergeben
    if (isset($_GET['bookid']))
	{
	    // Setze BuchId
	    $bookid = $_GET['bookid'];
	}

    if (isset ($_POST['submitBookDelete'])) 
	{  
	    $bookid = $_POST ['hiddenBookId'];
	}
 
   
    if ($bookid > 0) // Buch muss gespeichert werden
	{
	    try
		{
		    $DbMapper->deleteBook($bookid);
		    $message .= "Buch wurde geloescht";
		}
	    catch (Exception $e)
		{
		    LoggClass::loggErr
			("Fehler beim Loeschen des Buches");
		    $message .= "Buch konnte nicht geloescht werden";
		}
	}
} // if ( $Session->getState() >= 1 ) 
?>
<html>
<head>
</head>
<body>
  <table>
    <tr><td></td><td><h1>PHP Baukasten Beispielanwendung</h1></td></tr>
    <tr>
      <td><?php echo HtmlClass::getNaviBar($Session->getState()) ?></td>
      <td>
        <?php if ($Session->getState() >= 1): ?>
          <h2>Buch loeschen </h2>
          <?php echo $message; ?>
        <?php else: ?>
          Bitte loggen Sie sich erst ein.
        <?php endif; ?>
      </td>
    </tr>
  </table>
</body>   
</html>
