<?php
// ---------------------------------------------------------------------------
// PHP Baukasten Beispielanwendung
// Autor:  Susanne Pfeiffer / www.iloq.de
// E-Mail: susanne.pfeiffer@iloq.de
// ---------------------------------------------------------------------------

include ('globals.php');
include ('exceptionhandling.php');
include ('loggclass.php');
include ('session2class.php');
include ('bookdbmapperclass.php');
include ('authorclass.php');
include ('bookclass.php');
include ('html2class.php');

// Globale Benutzermeldung
$message = '';

// Instantiiere Session Objekt. 
// Wenn dabei ein Fehler auftritt 
// --> Abbruch und Aufruf Exception Handler
$Session = new SessionClass();

// Pruefe, ob Benutzer eingeloggt ist
if ( $Session->getState() >= 1 ) 
{
    // Lies Buecher aus Datenbank
    try
	{
	    $DbMapper = new BookDbMapperClass
		(DBNAME, DBUSER, DBPASSWORD);
	    $Books = $DbMapper->readBooks();
	}
    catch (Exception $e)
	{
	    $Books = array();
	    LoggClass::loggErr("Fehler beim Lesen der Buecher");
	    // setze Fehlermeldung 
	    $message = "Es ist ein Fehler aufgetreten :-(";
	}
}

?>

<html>
<head>
</head>
<body>
  <table>
    <tr>
      <td></td><td><h1>PHP Baukasten Beispielanwendung</h1></td>
    </tr>
    <tr>
      <td><?php echo HtmlClass::getNaviBar($Session->getState()) ?></td>
      <td>
        <?php if ($Session->getState() >= 1): ?>
          <h2>B&uuml;cherliste</h2>
          <table>
            <?php foreach ($Books as $bookid => $Book): ?>
              <tr>
                <td>
                  <?php echo $Book->getAuthorLastName() ?>, 
                  <?php echo $Book->getAuthorFirstName() ?>:&nbsp; 
                  <?php echo $Book->getTitle() ?>
                </td>
                <td><a href="bookview2.php?bookid=<?php   echo $bookid ?>">anzeigen</a></td>
                <td><a href="bookchange2.php?bookid=<?php echo $bookid ?>">aendern</a></td>
                <td><a href="bookdelete2.php?bookid=<?php echo $bookid ?>">loeschen</a></td>
              </tr>
            <?php endforeach; ?>
          </table>
          <a href="bookchange2?bookid=0">Neues Buch anlegen</a>
          <?php echo $message ?>
        <?php else: ?>
          Bitte loggen Sie sich erst ein.
        <?php endif; ?>
      </td>	
    </tr>
  </table>
</body>	   
</html>	   




