<?php
// ---------------------------------------------------------------------------
// PHP Baukasten Beispielanwendung
// Autor:  Susanne Pfeiffer / www.iloq.de
// E-Mail: susanne.pfeiffer@iloq.de
// ---------------------------------------------------------------------------

if (! defined('AUTHORCLASSPHP') )
{
    define ('AUTHORCLASSPHP', 'AUTHORCLASSPHP' );

    include ('globals.php');
    include ('exceptionhandling.php');
    include ('loggclass.php');
    

    // Autor-Klasse. 
    // Stellt einen Autor mit seinem Vor- und Nachamen dar
    class AuthorClass
    {
	private $lastname = '';
	private $firstname = '';

	public function __construct($lastname = '', 
				    $firstname = '')
	{
	    $this->lastname = $lastname;
	    $this->firstname = $firstname;
	}
	
	public function __destruct () {}

	public function setLastname ($lastname)
	{ $this->lastname = $lastname; }
	
	public function getLastname ()
	{ return $this->lastname; }

	public function checkLastname ()
	{ return ($this->lastname ? true: false); }

	public function setFirstname ($firstname)
	{ $this->firstname = $firstname; }

	public function getFirstname ()
	{ return $this->firstname; }

	public function checkFirstname ()
	{ return ($this->firstname ? true: false); }

	public function isValid()
	{ 
	    return $this->checkFirstname() 
		&& $this->checkLastname();
	}
	
	public function isEmpty()
	{
	    return ( ! $this->firstname
		     && ! $this->lastname );
	}

	public function __toString()
	{
	    return "lastname=" . $this->lastname
		. ";firstname=" . $this->firstname;
	}
    }
}
?>
