<?php
// ---------------------------------------------------------------------------
// PHP Baukasten Beispielanwendung
// Autor:  Susanne Pfeiffer / www.iloq.de
// E-Mail: susanne.pfeiffer@iloq.de
// ---------------------------------------------------------------------------


if (!defined('AUTHORDBMAPPERCLASSPHP'))
{
    define ('AUTHORDBMAPPERCLASSPHP', 'AUTHORDBMAPPERCLASSPHP');

    include ('globals.php');
    include ('exceptionhandling.php');
    include ('loggclass.php');
    include ('authorclass.php');
    include ('basedbclass.php');

    class AuthorDbMapperClass extends BaseDbClass
    {
	public function __construct($dbname, $dbuser, $dbpassword) 
	{
	    parent::__construct($dbname, $dbuser, $dbpassword);
	}
	
	public function __destruct() 
	{
	    LoggClass::logg("destruct authordbmapperclass");
	}
	
	public function readAuthors()
	{
	    $returnlist = array();
	    $sql = "select * from t_authors a;";

	    if ($result = pg_query($this->getConnection(), $sql))
		{
		    while ($row = pg_fetch_array($result))
			{
			    try
				{
				    $returnlist[$row['authorid']] 
					= new AuthorClass
					    ($row['lastname'], 
					     $row['firstname']);
				}
			    catch (Exception $e)
				{
				     LoggClass::loggErr
					 ("Fehler beim Listen der Autoren");
				     throw new Exception
					 ("Fehler beim Lesen der Autoren");
				}
			}
		}
	    else
		{
		    LoggClass::loggErr("Fehler beim Lesen der Autoren");
		    throw new Exception("Fehler beim Lesen der Autoren");
		};

	    return $returnlist;
	}

	public function readAuthorNames()
	{
	    $returnlist = array();
	    $sql = "select * from t_authors a;";

	    if ($result = pg_query($this->getConnection(), $sql))
		{
		    while ($row = pg_fetch_array($result))
			{
			    try
				{
				    $returnlist[$row['authorid']] 
					= $row['lastname'] . ', '  
					. $row['firstname'];
				}
			    catch (Exception $e)
				{
				     LoggClass::loggErr
					 ("Fehler beim Listen der Autoren");
				     return array();
				}
			}
		}
	    else
		{
		    LoggClass::loggErr("Fehler beim Lesen der Autoren");
		    return array();
				       
		};
	    return $returnlist;
	}

	public function readAuthor($authorid)
	{
	    $returnvalue = null;
	    
	    $sql = "select * from t_authors a "
		. "where a.authorid = $authorid ";

	    if ($result = pg_query($this->getConnection(), $sql))
		{
		    if (1 == pg_numrows($result))
			{
			    try
				{
				    $returnvalue =  
					new AuthorClass
					    (pg_result($result, 0, 'lastname'), 
					     pg_result($result, 0, 'firstname') );
				}
			    catch (Exception $e) { throw $e;}	
			}
		    else 
			{
			    $returnvalue = new AuthorClass;
			}
			
		}
	    else
		{
		    LoggClass::loggErr ("Fehler beim Lesen des Autors");
		    throw new Exception("Fehler beim Lesen des Autors");
				       
		};

	    return $returnvalue;
	}

	public function insertAuthor(& $Author)
	{
	    $returnvalue = null;
	    $sql = "select nextval('s_authors')";
	    if ($result = pg_query($this->getConnection(), $sql)
		and 1 == pg_numrows($result) )
		{
		    $returnvalue = pg_result ($result, 0, "nextval");
					 
		}
	    else
		{
		    LoggClass::loggErr ("Fehler beim Bestimmen der Id");
		    throw new Exception("Fehler beim Bestimmen der Id");
				       
		};
    
	    $sql = "insert into t_authors values "
		. "($returnvalue, " 
		. ", '" . $Author->getLastName() . "', "
		. "'" . $Author->getFirstName() . "')";
		
	    $result = pg_query($this->getConnection(), $sql);
		
	    if (! $result)
		{
		    LoggClass::loggErr("Fehler beim Speichern des Autors");
		    throw new Exception("Fehler beim des Autors");
		};

	    return $returnvalue;	    
	} 

	public function updateAuthor($authorid, & $Author)
	{
	    $sql = "update t_authors set "
		. "lastname = '" . $Author->getLastName() . "'"
		. ", firstname = '" . $Author->getFirstName() . "'"
		. " where authorid = $authorid";
		
	    $result = pg_query($this->getConnection(), $sql);
		
	    if (! $result)
		{
		    LoggClass::loggErr("Fehler beim Speichern des Autors");
		    throw new Exception("Fehler beim Speichern des Autors");
		};

	    return;	    
	}

	public function deleteAuthor($authorid)
	{
	    $sql = "delete from t_authors"
		. " where authorid = $authorid";
		
	    $result = pg_query($this->getConnection(), $sql);
		
	    if (! $result)
		{
		    LoggClass::loggErr("Fehler beim Loeschen des Autors");
		    throw new Exception("Fehler beim Loeschen des Autors");
		};
	    return;	    
	}
    }
}
?>
