<?php
// ---------------------------------------------------------------------------
// PHP Baukasten Beispielanwendung
// Autor:  Susanne Pfeiffer / www.iloq.de
// E-Mail: susanne.pfeiffer@iloq.de
// ---------------------------------------------------------------------------


if (!defined('BOOKDBMAPPERCLASSPHP'))
{
    define ('BOOKDBMAPPERCLASSPHP', 'BOOKDBMAPPERCLASSPHP');

    include ('globals.php');
    include ('exceptionhandling.php');
    include ('loggclass.php');
    include ('bookclass.php');
    include ('basedbclass.php');

    class BookDbMapperClass extends BaseDbClass
    {
	public function __construct($dbname, $dbuser, $dbpassword) 
	{
	    parent::__construct($dbname, $dbuser, $dbpassword);
	}
	
	public function __destruct() 
	{
	    LoggClass::logg("destruct BookDbMapper Instance");
	}
	
	public function readBooks()
	{
	    $returnlist = array();
	    $sql = "select * from t_books b, t_authors a "
		. "where a.authorid = b.authorid;";

	    if ($result = pg_query($this->getConnection(), $sql))
		{
		    while ($row = pg_fetch_array($result))
			{
			    try
				{
				    $returnlist[$row['bookid']] 
					= new BookClass
					    ($row['authorid'], 
					     new AuthorClass
						 ($row['lastname'], 
						  $row['firstname']), 
					     $row['title'], 
					     $row['subtitle']);
				}
			    catch (Exception $e)
				{
				     LoggClass::loggErr
					 ("Fehler beim Listen der Buecher");
				     throw new Exception
					 ("Fehler beim Lesen der Buecher");
				}
			}
		}
	    else
		{
		    LoggClass::loggErr("Fehler beim Lesen der Buecher");
		    throw new Exception("Fehler beim Lesen der Buecher");
		};

	    return $returnlist;
	}

	public function readBook($bookid)
	{
	    $returnvalue = null;
	    
	    $sql = "select * from t_books b, t_authors a "
		. "where a.authorid = b.authorid "
		. "and bookid = $bookid";

	    if ($result = pg_query($this->getConnection(), $sql))
		{
		    if (1 == pg_numrows($result))
			{
			    try
				{
				    $returnvalue = new BookClass 
					(pg_result
					 ($result, 0, 'authorid'), 
					 new AuthorClass
					    (pg_result($result, 0, 'lastname'), 
					     pg_result($result, 0, 'firstname') ), 
					 pg_result($result, 0, 'title'), 
					 pg_result($result, 0, 'subtitle') );
				}
			    catch (Exception $e) { throw $e;}	
			}
		    else 
			{
			    $returnvalue = new BookClass;
			}
		}
	    else
		{
		    LoggClass::loggErr("Fehler beim Lesen des Buches");
		    throw new Exception("Fehler beim Lesen des Buches");
		};

	    return $returnvalue;
	}

	public function insertBook(& $Book)
	{
	    $returnvalue = null;
	    $sql = "select nextval('s_books')";
	    if ($result = pg_query($this->getConnection(), $sql)
		and 1 == pg_numrows($result) )
		{
		    $returnvalue = pg_result ($result, 0, 'nextval');
					 
		}
	    else
		{
		    LoggClass::loggErr("Fehler beim Bestimmen der Id");
		    throw new Exception("Fehler beim Bestimmen der Id", 0);
				       
		};
    
	    $sql = "insert into t_books values "
		. "($returnvalue, " . $Book->getAuthorId()
		. ", '" . $Book->getTitle() . "', "
		. "'" . $Book->getSubtitle() . "')";
		
	    $result = pg_query($this->getConnection(), $sql);
		
	    if (! $result)
		{
		    LoggClass::loggErr("Fehler beim Speichern des Buches");
		    throw new Exception("Fehler beim des Buches");
		};
	    return $returnvalue;	    
	}

	public function updateBook($bookid, & $Book)
	{
	    $sql = "update t_books set "
		. "authorid = " . $Book->getAuthorId()
		. ", title = '" . $Book->getTitle() . "'"
		. ", subtitle = '" . $Book->getSubtitle() . "'"
		. " where bookid = $bookid";
		
	    $result = pg_query($this->getConnection(), $sql);
		
	    if (! $result)
		{
		    LoggClass::loggErr("Fehler beim Speichern des Buches");
		    throw new Exception("Fehler beim Speichern des Buches");
				       
		};

	    return;	    
	}

	public function deleteBook($bookid)
	{
	    $sql = "delete from t_books"
		. " where bookid = $bookid";
		
	    $result = pg_query($this->getConnection(), $sql);
		
	    if (! $result)
		{
		    LoggClass::loggErr("Fehler beim Loeschen des Buches");
		    throw new Exception("Fehler beim Loeschen des Buches");
		};
	    return;	    
	}
    }
}
?>
