<?php
// ---------------------------------------------------------------------------
// PHP Baukasten Beispielanwendung
// Autor:  Susanne Pfeiffer / www.iloq.de
// E-Mail: susanne.pfeiffer@iloq.de
// ---------------------------------------------------------------------------


if (!defined('HTMLCLASSPHP'))
{
    define ('HTMLCLASSPHP', 'HTMLCLASSPHP');

    include ('globals.php');
    include ('loggclass.php');

    class HtmlClass
    {
	private $username = 0;

	// Konstruktor
	// privat, da die HTML-Klasse nicht instanziiert werden soll. 
	private function __construct()
	{
	}

	// getSelectTag
	// Methode zur Generierung eines select-Tags aufgrund eines 
	// uebergebenen assoziativen Arrays. 
	// Parameter: 
	// name - Name des zu generierenden Select-Tags
	// options - assoziatives Array, das die Schluessel und Werte des 
	//           zu generierenden Select-Tags enthaelt. 
	// selected - Schluessel der zu selektierenden Option. 
	//            Falls kein Schluessel uebergeben wird, wird keine
	//            Option selektiert. 
	public static function getSelectTag($name, $options, $selected = 0)
	{
	    $returnvalue = "<select name=\"$name\">\n";
	    if (is_array($options))
		{
		    foreach ($options as $optionkey => $optionvalue)
			{
			    $returnvalue 
				.= "<option value=\"" . $optionkey . "\"";
			    if ($selected == $optionkey)
				{$returnvalue .= " selected";}
			    $returnvalue .= ">"
				.  $optionvalue
				. "</option>\n";
			}
		}
	    $returnvalue .= "</select>\n";
	    return $returnvalue;
	}	

	// getNaviBar
	// Methode zur Generierung einer Sessionstatus-abhaengigen
	// Navigationsleiste. 
	public static function getNaviBar($sessionstate)
	{
	    $returnvalue .= "<table>\n";

	    // Der Link zur Homepage soll immer enthalten sein. 
	    $returnvalue .= "<tr><td>"
		. "<a href=\"index.php\">"
		. "Home</a>"
		. "</td></tr>\n";

	    // Pruefe, ob eingeloggt
	    if ($sessionstate)
		{
		    // Falls eingeloggt, 
		    // sollen die Links zur Buecherliste
		    // und zur Logout-Seite angezeigt werden ... 
		    $returnvalue .= "<tr><td>"
			. "<a href=\"booklist.php\">"
			. "B&uuml;cher</a>"
			. "</td></tr>\n"
			. "<tr><td>"
			. "<a href=\"logout.php\">"
			. "Logout</a>"
			. "</td></tr>\n";
		}

	    else
		{
		    // ... andernfalls nur der Link zur Login-Seite. 
		    $returnvalue .= "<tr><td>"
			. "<a href=\"login.php\">"
			. "Login</a>"
			. "</td></tr>\n";
		}

	    $returnvalue .= "</table>\n";
	    return $returnvalue;
	}


    }
}
?>
