<?php
// ---------------------------------------------------------------------------
// PHP Baukasten Beispielanwendung
// Autor:  Susanne Pfeiffer / www.iloq.de
// E-Mail: susanne.pfeiffer@iloq.de
// ---------------------------------------------------------------------------

if (!defined('USERDBMAPPERCLASSPHP'))
{
    define ('USERDBMAPPERCLASSPHP', 'USERDBMAPPERCLASSPHP');

    include ('globals.php');
    include ('exceptionhandling.php');
    include ('loggclass.php');
    include ('userclass.php');
    include ('basedbclass.php');

    class UserDbMapperClass extends BaseDbClass
    {

	// Konstruktor
	public function __construct($dbname, $dbuser, $dbpassword) 
	{
	    parent::__construct($dbname, $dbuser, $dbpassword);
	}
	
	public function __destruct() {}
	
	// readUser
	// Methode zum Lesen eines Benutzers aus der Datenbank
	// aufgrund eines gegebenne Benutzernamens. 
	public function readUser($username)
	{
	    $returnvalue = null;
	    
	    $sql = "select * from t_users  "
		. "where username = '" . $username . "'"; 

	    if ($result = pg_query($this->getConnection(), $sql))
		{
		    if (1 == pg_numrows($result))
			{
			    try
				{
				    $returnvalue = new UserClass 
					(pg_result($result, 0, 'username'),
					 pg_result($result, 0, 'lastname'), 
					 pg_result($result, 0, 'firstname'), 
					 pg_result($result, 0, 'password'));
				}
			    catch (Exception $e) 
				{ 
				    LoggClass::loggErr 
					("Fehler beim Lesen aus der DB");
				    throw new Exception 
					("Fehler beim Lesen aus der DB");}	
			}
		    else 
			{
			    LoggClass::loggErr("Benutzer nicht gefunden");
			    throw new Exception("Benutzer nicht gefunden");
			}
		}
	    else
		{
		    LoggClass::loggErr("Fehler beim Lesen des Benutzers");
		   throw new Exception("Fehler beim Lesen des Benutzers");
		};
	    return $returnvalue;
	}	

    }
}
?>
